
.nolist
#include	"asm83.inc"
#include	"sos.inc"


#define	top_addr		sram+$0000
#define	end_addr		sram+$0002
#define	cur_addr		sram+$0004

#define	barpos		sram+$0006
#define	barwidth		sram+$0007
#define	barfunct		sram+$0008

#define	afReg			sram+$0009
#define	hlReg			sram+$000A
#define	bcReg			sram+$000C
#define	deReg			sram+$000E

#define	bytesnum		sram+$0010
#define	mode			sram+$0011

#define	screenw		sram+$0012

#define	nextline_addr	sram+$0014

#define	temp			sram+$0016

#define	addressPTR		sram+$0017
#define	progp			sram+$0019
#define	progaddress		sram+$001B
#define	progdata		sram+$001D


.list
.org	$9327


	nop
	jr	ProgStart
	.dw	$0000
	.dw	Description

ProgStart:

	ld	(afReg),a
	ld	(hlReg),hl
	ld	(bcReg),bc
	ld	(deReg),de

	set	7,(iy+20)

	ld	hl,$0000
	ld	(top_addr),hl
	ld	(cur_addr),hl
	xor	a
	ld	(barpos),a
	ld	(barfunct),a
	ld	(mode),a
	ld	(temp),a
	inc	a
	ld	(screenw),a



moveloop:

	call	ChooseViewer
	call	_bufcopy

mainLoop:
	call	$024e			;=$4014

	cp	$35			;[Y=]
	jp	z,Disassembler
	cp	$34			;[WINDOW]
	jp	z,HexEdit
	cp	$33			;[ZOOM]
	jp	z,GraphView
	cp	$32			;[TRACE]
	jp	z,LoadProgram
	cp	$31			;[GRAPH]
	jp	z,ChooseAddr

	cp	$09			;[ENTER]
	call	z,refresh

;	cp	$30			;[ALPHA]
;	call	z,EditMode

;	cp	$0F
;	jp	z,exit

	ld	a,$0ff
	out	(1),a
	ld	a,$0bf
	out	(1),a
	in	a,(1)
	cp	191
	jp	z,exit

	ld	a,$0ff
	out	(1),a
	ld	a,$0fe
	out	(1),a
	in	a,(1)
	cp	254
	jr	z,mDown
	cp	247
	jr	z,mUp

	jr	mainLoop



mDown:
	ld	a,(mode)
	or	a
	jp	z,disDown
	dec	a
	jp	z,zhxDown
	dec	a
	jp	z,zghDown


mUp:
	ld	a,(mode)
	or	a
	jp	z,disUp
	dec	a
	jp	z,zhxUp
	dec	a
	jp	z,zghUp



ChooseViewer:
	ld	a,(mode)
	or	a
	jp	z,DisassemblerStuff
	dec	a
	jp	z,HexEditStuff
	dec	a
	jp	z,GraphViewStuff
	ret


DisassemblerStuff:
	ld	hl,(cur_addr)
	ld	(top_addr),hl

	call	DrawScreen


	call	Disp_cur_addr
	call	Disp_Registers
	jp	Disp_Code

;	call	HiLighCode

;	ret


HexEditStuff:
	call	DrawScreen
	call	Disp_cur_addr
	call	Disp_Registers
	jp	Disp_HexCode
;	ret


GraphViewStuff:
	jp	Done		;paradoxal !? ... nah !
;	ret



;+----------------------------------------------------+
;exit & refresh registers label
;+----------------------------------------------------+
									;
exit:									;
	res	7,(iy+20)						;
	ret								;
									;
									;
refresh:								;
	ld	(afReg),a						;
	ld	(hlReg),hl						;
	ld	(bcReg),bc						;
	ld	(deReg),de						;
									;
	ld	a,(mode)						;
	cp	2							;
	ret	z							;
									;
	call	disp_registers					;
	jp	_bufcopy						;
									;
									;
;+----------------------------------------------------+




;+----------------------------------------------------+
;highlight a section of the screen at hl (+width)
;+----------------------------------------------------+
									;
HiLighCode:								;
	ld	hl,plotsscreen+(12*7)				;
	ld	a,8							;
	ld	(barwidth),a					;
	jr	hilight						;
HiLighReg:								;
	ld	hl,plotsscreen+(12*7)+8				;
	ld	a,4							;
	ld	(barwidth),a					;
	jr	hilight						;
HiLighAddr:								;
	ld	hl,plotsscreen+(12*56)+8			;
	ld	a,4							;
	ld	(barwidth),a					;
	jr	nooperation						;
									;
									;
									;
hilight:								;
	ld	a,(barpos)						;
	or	a							;
	jr	z,nooperation					;
	ld	b,a							;
	ld	de,12*7						;
godown:								;
	add	hl,de							;
	djnz	godown						;
nooperation:							;
	ld	b,7							;
hmloop:								;
	push	bc							;
	ld	a,%01111111						;
	ld	b,a							;
	ld	a,(hl)						;
	xor	b							;
	ld	(hl),a						;
	ld	a,(barwidth)					;
	sub	2							;
	ld	b,a							;
hlloop:								;
	inc	hl							;
	ld	a,(hl)						;
	cpl								;
	ld	(hl),a						;
	djnz	hlloop						;
	inc	hl							;
	ld	a,%11111110						;
	ld	b,a							;
	ld	a,(hl)						;
	xor	b							;
	ld	(hl),a						;
	ld	a,(barwidth)					;
	dec	a							;
	ld	b,a							;
	ld	a,12							;
	sub	b							;
	ld	e,a							;
	ld	d,$00							;
	add	hl,de							;
	pop	bc							;
	djnz	hmloop						;
	ret								;
									;
;+----------------------------------------------------+




;+----------------------------------------------------+
;display af,hl,bc and de registers
;+----------------------------------------------------+
									;
Disp_Registers:							;
									;
	ld	de,7*256+66						;
	ld	(pencol),de						;
	ld	hl,reg1						;
	call	_vputs						;
	ld	a,(afReg)						;
	call	_dispHex						;
									;
									;
	ld	hl,reg2						;
	ld	de,14*256+66					;
	ld	(pencol),de						;
	call	_vputs						;
	ld	bc,(bcReg)						;
	push	bc							;
	ld	a,b							;
	call	_dispHex						;
	pop	bc							;
	ld	a,c							;
	call	_dispHex						;
									;
									;
	ld	hl,reg3						;
	ld	de,21*256+66					;
	ld	(pencol),de						;
	call	_vputs						;
	ld	de,(deReg)						;
	push	de							;
	ld	a,d							;
	call	_dispHex						;
	pop	de							;
	ld	a,e							;
	call	_dispHex						;
									;
									;
	ld	hl,reg4						;
	ld	de,28*256+66					;
	ld	(pencol),de						;
	call	_vputs						;
	ld	hl,(hlReg)						;
	ld	a,h							;
	push	hl							;
	call	_dispHex						;
	pop	hl							;
	ld	a,l							;
	jp	_dispHex						;
									;
									;
reg1:		.db	"af=",0					;
reg2:		.db	"bc=",0					;
reg3:		.db	"de=",0					;
reg4:		.db	"hl=",0					;
									;
;+----------------------------------------------------+




;+----------------------------------------------------+
;display the equivalent opcodes of the selected line
;+----------------------------------------------------+
									;
Disp_Hex:								;
	ld	c,0							;
	ld	a,4							;
	ld	(bytesnum),a					;
	ld	de,42*256+66					;
	ld	(pencol),de						;
	ld	a,(bytesnum)					;
	ld	b,a							;
	cp	4							;
	call	z,SetNextLine					;
;	ld	hl,bytes						;
loop:									;
	ld	a,(hl)						;
	inc	hl							;
	push	hl							;
	call	_dispHex						;
	ld	a,' '							;
	call	_vputmap						;
	pop	hl							;
	djnz	loop							;
	ld	a,c							;
	or	a							;
	ret	z							;
	ld	de,48*256+66					;
	ld	(pencol),de						;
	ld	a,(hl)						;
	jp	_dispHex						;
SetNextLine:							;
	ld	c,1							;
	dec	b							;
	ret								;
									;
;+----------------------------------------------------+




;+----------------------------------------------------+
;display the current addr (at selection)
;+----------------------------------------------------+
									;
Disp_cur_addr:							;
									;
	ld	de,56*256+72					;
	ld	(pencol),de						;
									;
	ld	hl,(cur_addr)					;
	ld	a,h							;
	push	hl							;
	call	_dispHex						;
	pop	hl							;
	ld	a,l							;
	call	_dispHex						;
									;
	ret								;
									;
;+----------------------------------------------------+




;+----------------------------------------------------+
;setup screen with 3 windows
;+----------------------------------------------------+
									;
DrawScreen:								;
	xor	a							;
	ld	e,a							;
	ld	b,8							;
	ld	c,56							;
	ld	hl,wintxt						;
	call	OpenWindow						;
									;
	ld	a,8							;
	ld	e,0							;
	ld	b,4							;
	ld	c,28							;
	call	OpenWindow						;
									;
	ld	a,8							;
	ld	e,35							;
	ld	b,4							;
	ld	c,21							;
	call	OpenWindow						;
									;
	ld	b,65							;
	ld	c,8							;
	ld	d,96							;
	ld	e,8							;
	ld	h,1							;
	jp	_iline						;
									;
;+----------------------------------------------------+




;+----------------------------------------------------+
;text printed
;+----------------------------------------------------+
									;
Description:	.db	"Diz 0.7",0				;
									;
wintxt:		.db	"Code",0				;
			.db	"Reg",0				;
			.db	"Hex",0				;
									;
;+----------------------------------------------------+




;+----------------------------------------------------+
;files that contains routines & opcodes
;+----------------------------------------------------+
									;
#include	"window.h"						;
#include	"hex.h"						;
									;
#include	"zaddr.asm"						;
#include	"zldprog.asm"					;
#include	"zds.asm"						;
#include	"zhx.asm"						;
#include	"zgh.asm"						;
									;
#include	"opcodes.h"						;
									;
;+--------------------------------------------------- +




.end
