
;+--------------------------------------------------------------+
;|	   OpenWindow routine v1.0  made by Jean Carot		|
;|		   Email: yhean@mailcity.com			|
;|		     Last update: 16/09/99			|
;+--------------------------------------------------------------+
;
;input: (a,e) top-left corner
;       (b,c) (width,height)
;	   hl-pointer to title string
;note:  b MUST NOT be <3, or it will crash...

OpenWindow:
	push	hl		;<---find position

	ld	hl,TextCoords
	ld	(hl),a
	ld	hl,TextCoords+1
	ld	(hl),e

	ld	hl,0
	ld	d,0
	add	hl,de
	add	hl,de
	add	hl,de

	add	hl,hl
	add	hl,hl

	ld	e,a
	ld	d,0
	add	hl,de
	ld	de,plotsscreen
	add	hl,de



	ld	d,b		;<---start drawing window (title area)
	ld	a,12
	sub	d
	ld	e,a

	ld	a,7
NextLine:
	push	af
	push	bc
TitleArea:
	ld	a,$ff
	ld	(hl),a
	inc	hl
	djnz	TitleArea

	ld	d,0
	add	hl,de

	pop	bc
	pop	af
	dec	a
	or	a
	jr	nz,NextLine



	ld	a,12		;<---draw frame area
	ld	e,b
	dec	e
	sub	e
	ld	e,a
	ld	d,0

	ld	a,b
	sub	2
	ld	b,a

	ld	a,c
DrawWindow:
	push	af
	push	bc
	push	de
	call	LeftSide
FrameArea:
	inc	hl
	ld	a,$00
	ld	(hl),a
	djnz	FrameArea

	inc	hl
	call	RightSide

	pop	de
	add	hl,de

	pop	bc
	pop	af
	dec	a
	or	a
	jr	nz,DrawWindow



	ld	a,b		;<---last line of window
	add	a,2
	ld	b,a
LastLine:
	ld	a,$ff
	ld	(hl),a
	inc	hl
	djnz	LastLine



	ld	a,(TextCoords)	;<---calculate text coords
	sla	a
	sla	a
	sla	a
	inc	a
	ld	e,a
	ld	a,(TextCoords+1)
	ld	d,a
	ld	(pencol),de
	pop	hl
;	set	7,(iy+20)
	set	3,(iy+5)
	call	_vputs
	res	3,(iy+5)
;	res	7,(iy+20)

	ret			;<---done

LeftSide:
	ld	a,%10000000
	ld	(hl),a
	ret
RightSide:
	ld	a,%00000001
	ld	(hl),a
	ret


TextCoords:
.db	0,0
